Imports System.Xml.Serialization
Imports System.IO

Public Class Form1
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Make a SerializableDictionary.
        Dim dict As New SerializableDictionary(Of String, Person)
        dict.Add("one", New Person("Ann", "Archer"))
        dict.Add("two", New Person("Bob", "Box"))
        dict.Add("three", New Person("Cindy", "Cant"))
        dict.Add("four", New Person("Dan", "Dive"))
        dict.Add("five", New Person("Edwina", "Eagle"))

        ' Show the serialization.
        Dim txt As String = ""
        Dim xml_serializer As New XmlSerializer(GetType(SerializableDictionary(Of String, Person)))
        Try
            Using string_writer As New StringWriter()
                xml_serializer.Serialize(string_writer, dict)
                txt = string_writer.ToString
                string_writer.Close()
            End Using
        Catch ex As Exception
            Stop
        End Try

        ' Deserialize.
        Using string_reader As New StringReader(txt)
            dict = DirectCast(xml_serializer.Deserialize(string_reader), SerializableDictionary(Of String, Person))
        End Using

        txt &= vbCrLf & "***********" & vbCrLf
        For Each key As String In dict.Keys
            txt &= key & ": " & dict.Item(key).ToString() & vbCrLf
        Next key

        txtResult.Text = txt
        txtResult.Select(0, 0)
    End Sub
End Class
